Index: contrib/arch/uspace/app/klog/klog.bp
===================================================================
--- contrib/arch/uspace/app/klog/klog.bp	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
+++ contrib/arch/uspace/app/klog/klog.bp	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
@@ -0,0 +1,1 @@
+!ns.IPC_SHARE_IN /* SERVICE_MEM_KLOG */
Index: contrib/arch/uspace/lib/libfs/fs_register
===================================================================
--- contrib/arch/uspace/lib/libfs/fs_register	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
+++ contrib/arch/uspace/lib/libfs/fs_register	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
@@ -0,0 +1,4 @@
+!vfs.VFS_IN_REGISTER ;
+!vfs.IPC_M_DATA_WRITE /* vfs_into_t */ ;
+!vfs.IPC_M_CONNECT_TO_ME ;
+!vfs.IPC_M_SHARE_IN
Index: contrib/arch/uspace/lib/libfs/libfs_lookup
===================================================================
--- contrib/arch/uspace/lib/libfs/libfs_lookup	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
+++ contrib/arch/uspace/lib/libfs/libfs_lookup	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
@@ -0,0 +1,1 @@
+!fs.VFS_OUT_LOOKUP*
Index: contrib/arch/uspace/lib/libfs/libfs_mount
===================================================================
--- contrib/arch/uspace/lib/libfs/libfs_mount	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
+++ contrib/arch/uspace/lib/libfs/libfs_mount	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
@@ -0,0 +1,6 @@
+?IPC_M_CONNECTION_CLONE ;
+?IPC_M_DATA_WRITE /* mount options */ {
+	!fs.IPC_M_CONNECT_ME ;
+	!fs.VFS_OUT_MOUNTED ;
+	!fs.IPC_M_DATA_WRITE /* forwarded */
+}
Index: contrib/arch/uspace/lib/libfs/libfs_stat
===================================================================
--- contrib/arch/uspace/lib/libfs/libfs_stat	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
+++ contrib/arch/uspace/lib/libfs/libfs_stat	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
@@ -0,0 +1,1 @@
+?IPC_M_DATA_READ
Index: contrib/arch/uspace/srv/devmap/devmap.bp
===================================================================
--- contrib/arch/uspace/srv/devmap/devmap.bp	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
+++ contrib/arch/uspace/srv/devmap/devmap.bp	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
@@ -0,0 +1,42 @@
+!ns.IPC_M_CONNECT_TO_ME ;
+(
+	?IPC_M_CONNECT_ME_TO ;
+	(
+		( /* driver interface */
+			?DEVMAP_DEVICE_REGISTER {
+				?IPC_M_DATA_WRITE /* name */
+			} +
+			
+			?DEVMAP_DEVICE_GET_HANDLE {
+				?IPC_M_DATA_WRITE /* name */
+			} +
+			
+			?DEVMAP_DEVICE_GET_NAME +
+			
+			?DEVMAP_DEVICE_UNREGISTER +
+			
+			?DEVMAP_DRIVER_UNREGISTER
+		) +
+		
+		( /* client interface */
+			?DEVMAP_DEVICE_GET_HANDLE {
+				?IPC_M_DATA_WRITE /* name */
+			} +
+			
+			?DEVMAP_DEVICE_GET_NAME +
+			
+			?DEVMAP_DEVICE_NULL_CREATE +
+			
+			?DEVMAP_DEVICE_NULL_DESTROY +
+			
+			?DEVMAP_DEVICE_GET_COUNT +
+			
+			?DEVMAP_DEVICE_GET_DEVICES {
+				?IPC_M_DATA_READ /* buffer */
+			}
+		) +
+		
+		!dev.IPC_M_CONNECT_ME_TO /* forwarded */
+	)* ;
+	?IPC_M_PHONE_HUNGUP
+)*
Index: uspace/srv/hid/kbd/port/i8042.h
===================================================================
--- uspace/srv/hid/kbd/port/i8042.h	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
+++ uspace/srv/hid/kbd/port/i8042.h	(revision 6c017023ebfaf5820d1a7aaa61128c5fc053fe88)
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2006 Josef Cejka
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kbd_port
+ * @ingroup  kbd
+ * @{
+ */
+
+/** @file
+ * @brief i8042 port driver.
+ */
+
+#ifndef KBD_PORT_i8042_H_
+#define KBD_PORT_i8042_H_
+
+#include <libarch/ddi.h>
+#include <libarch/types.h>
+
+struct i8042 {
+	ioport8_t data;
+	uint8_t pad[3];
+	ioport8_t status;
+} __attribute__ ((packed));
+typedef struct i8042 i8042_t;
+
+#endif
+
+/**
+ * @}
+ */ 
